{ 010429-2.PAS                                                              }
{ 2001-04-29 programmeerimisolmpiaadi 2. lesande lahendus                 }
{    PAANID                                                                 }
{ Oleg Mrk                                                                 }
{ Testitud: TP 7.0, FPC 1.04/GO32V2                                         }

{$R-}{$Q-}{$S-}{$I+}{$N+}
const
 MAX_N = 50;
 MinLongInt = -MaxLongInt - 1;
 INPUT_FILE = 'PAANID.SIS';
 OUTPUT_FILE = 'PAANID.VAL';

type
 rectangle = record
                   x1, y1, x2, y2 : integer;
             end;
 solution = array[1 .. MAX_N * MAX_N] of rectangle;

var
 xs, ys: integer;
 map:array[1 .. MAX_N, 1 .. MAX_N] of longint;
 used:array[1 .. MAX_N, 1 .. MAX_N] of boolean;
 sums:array[0 .. MAX_N, 0 .. MAX_N] of longint;

 limit : longint;
 next_limit : longint;

 cur_max:longint;
 cur_n:integer;
 cur_sol:solution;

 best_found:boolean;
 best_max:longint;
 best_n:integer;
 best_sol:solution;

 cur_free_sum : longint;
 cur_free_n : integer;

 stat_enter : longint;
 stat_cut1 : longint;
 stat_cut2 : longint;

function max(a,b:longint):longint;
begin
 if (a < b) then max:=b else max:=a;
end;

function min(a,b:longint):longint;
begin
 if (a > b) then min:=b else min:=a;
end;

function ceil(r : double):longint;
var
 e : longint;

begin
    e := trunc(r);
    if (r > 0) and (r - e <> 0) then inc(e);
    ceil := e;
end;

function sum(x1, y1, x2, y2:integer):longint;
begin
     sum := sums[x2, y2] -
            (sums[x2, y1 - 1] + sums[x1 - 1, y2]) +
            sums[x1 - 1, y1 - 1];
end;

procedure input;
var
 f:text;
 x, y:integer;
begin
     assign(f, INPUT_FILE);
     reset(f);
     readln(f, ys, xs);

     for y := 1 to ys do
     begin
      for x := 1 to xs do
       read(f, map[x,y]);
      readln(f);
     end;
     close(f);
end;

procedure search(cx, cy:integer);
var
 ok : boolean;
 x, y, l, l1 : integer;
 max_y : integer;
 est_max : longint;

 function estimate:longint;
 var
  r : double;
  e : longint;
 begin
  estimate:=cur_max;


  if (cur_free_n = 0) then exit;

  if (cur_free_sum < 0) then
      estimate := max(cur_max, cur_free_sum)
  else
      estimate := max(cur_max, ceil(cur_free_sum/cur_free_n));

 end;

 procedure try(x1, y1, x2, y2 : integer);
 var
  l : integer;
  rarea : longint;
  rsum, sum1, sum2 : longint;
  save_cur_max : longint;


  function test(sum1, sum2:integer):boolean;
  begin
       if ((sum1 <= limit) and (sum2 <= limit)) then test:=false
          else test:=true;
  end;

 begin
     rarea := (x2 - x1 + 1) * (y2 - y1 + 1);
     rsum := sum(x1, y1, x2, y2);

     for l:= x1 to x2-1 do
     begin
       sum1 := sum(x1, y1, l, y2);
       sum2 := sum(l+1, y1, x2, y2);
       if not test(sum1, sum2) then
       begin
          inc(stat_cut1);
          exit;
       end;
     end;

     for l:= y1 to y2-1 do
     begin
       sum1 := sum(x1, y1, x2, l);
       sum2 := sum(x1, l+1, x2, y2);
       if not test(sum1, sum2) then
       begin
          inc(stat_cut1);
          exit;
       end;
     end;

     save_cur_max := cur_max;
     cur_max := max(cur_max, rsum);
     inc(cur_n);
     cur_sol[cur_n].x1 := x1;
     cur_sol[cur_n].y1 := y1;
     cur_sol[cur_n].x2 := x2;
     cur_sol[cur_n].y2 := y2;

     dec(cur_free_sum, rsum);
     dec(cur_free_n, rarea);

     search(x1, y1);

     inc(cur_free_n, rarea);
     inc(cur_free_sum, rsum);

     dec(cur_n);
     cur_max := save_cur_max;
 end;

begin
     inc(stat_enter);
     if ((stat_enter mod 1000000) = 0) then
     begin
          write('?');
          readln;
     end;

     est_max := estimate;

     if (est_max > limit) then
     begin
          inc(stat_cut2);
          next_limit := min(next_limit, est_max);
          exit;
     end;

     while (cx <= xs) or (cy <= ys) do
     begin
          if (not used[cx,cy]) then break;
          if (cx < xs) then inc(cx)
          else
          begin
               inc(cy);
               cx := 1;
          end;
     end;

     if (cy > ys) then
     begin
          if (not best_found) then
          begin
               best_found := true;
               best_max := cur_max;
               best_n := cur_n;
               best_sol := cur_sol;
          end;
          exit;
     end;

     for x := cx to xs do
     begin

      max_y := cy - 1;

      for y := cy to ys do
      begin
       if (best_found) then break;

       ok := true;
       for l := cx to x do
        if used[l, y] then
        begin
         ok:=false;
         break;
        end;

       if not ok then break;

       for l := cx to x do used[l, y]:=true;

       inc(max_y);

       try(cx, cy, x, y);
      end;

      for l := cy to max_y do
       for l1 := cx to x do
        used[l1, l] := false;
     end;
end;

procedure work;
 procedure init;
 var
  x, y:integer;
  s:longint;
 begin
     for x:=1 to xs do
      for y:=1 to ys do
       used[x,y]:=false;


     for x:=1 to xs do sums[x, 0] := 0;
     for y:=1 to ys do sums[0, y] := 0;

     for y:=1 to ys do
     begin
          s:=0;
          for x := 1 to xs do
          begin
               inc(s, map[x,y]);
               sums[x,y] := sums[x,y-1] + s;
          end;
     end;
 end;

begin
     init;

     stat_cut1 := 0;
     stat_cut2 := 0;
     stat_enter := 0;

     best_found := false;
     best_max := MaxLongInt;

     cur_max := MinLongInt;
     cur_n := 0;

     next_limit := MinLongInt;

     cur_free_sum := sums[xs, ys];
     cur_free_n := xs*ys;

     writeln;

     while not best_found do
     begin
          limit := next_limit;
          next_limit := MaxLongInt;

          write(limit, ' ... ');

          search(1, 1);

          if (next_limit = MaxLongInt) then next_limit := limit + 1;
     end;
     writeln;
     writeln('Statistic: ', stat_cut1, ' : ', stat_cut2, ' / ', stat_enter);
end;

procedure output;
var
 f:text;
 l:integer;
begin
     assign(f, OUTPUT_FILE);
     rewrite(f);
     writeln(f,  best_n);
     for l:=1 to best_n do
      writeln(f, best_sol[l].y1, ' ', best_sol[l].x1, ' ',
                 best_sol[l].y2, ' ', best_sol[l].x2, ' ');
     close(f);
end;

begin
     input;
     work;
     output;
end.
