{ 010429-3.PAS                                                              }
{ 2001-04-29 programmeerimisolmpiaadi 3. lesande lahendus                 }
{    RISTKLIKUD                                                            }
{ Ahto Truu                                                                 }
{ Testitud: TP 6.0, FPC 1.04/GO32V2                                         }

const
   maxn = 200;
   sisf = 'ristk.sis';
   valf = 'ristk.val';

type
   punkt = record
      x, y : integer;
   end;
   nelik = record
      p1, p2, p3, p4 : punkt;
   end;

{ arvutab punktidevahelise kauguse ruudu }
function kaug_ruut (var p1, p2 : punkt) : longint;
var dx, dy : longint;
begin
   dx := p1.x - p2.x;
   dy := p1.y - p2.y;
   kaug_ruut := sqr (dx) + sqr (dy);
end;

{ kontrollib, kas nelinurk on ristklik }
function on_ristk (var x : nelik) : boolean;
begin
   on_ristk := 
      (kaug_ruut (x.p1, x.p2) = kaug_ruut (x.p3, x.p4)) and
      (kaug_ruut (x.p1, x.p3) = kaug_ruut (x.p2, x.p4)) and
      (kaug_ruut (x.p1, x.p4) = kaug_ruut (x.p2, x.p3));
end;

{ vahetab kahe muutuja vrtused }
procedure vaheta (var l1, l2 : longint);
var l : longint;
begin
   l := l1; l1 := l2; l2 := l;
end;

{ kontrollib, kas teine ristklik mahub esimese sisse }
function mahub (var x1, x2 : nelik) : boolean;
var a1, b1, a2, b2, d2 : longint;
var s1, c1, s2, c2, s, c, h : real;
begin
   a1 := kaug_ruut (x1.p1, x1.p2); b1 := kaug_ruut (x1.p2, x1.p3);
   if a1 < b1 then
      vaheta (a1, b1);
   a2 := kaug_ruut (x2.p1, x2.p2); b2 := kaug_ruut (x2.p2, x2.p3);
   if a2 < b2 then
      vaheta (a2, b2);
   if (a2 < a1) and (b2 < b1) then begin
      mahub := true;
   end else if (a2 >= a1) and (b2 < b1) then begin
      d2 := a2 + b2;
      s1 := sqrt (d2 - a1); c1 := sqrt (a1);
      s2 := sqrt (b2); c2 := sqrt (a2);
      s := s1 * c2 + c1 * s2; c := c1 * c2 - s1 * s2;
      h := (sqrt (a2) * s + sqrt (b2) * c) / d2;
      mahub := sqr (h) < b1;
   end else begin
      mahub := false;
   end;
end;

var
   r : integer;                                          { ristklikute arv }
   a : array [1..maxn] of record                      { ristklikute andmed }
      n : integer;                                { jrjekorranumber failis }
      x : nelik;                                            { ristklik ise }
      m : array [1..maxn] of boolean;         { millised tema sisse mahuvad }
      p : integer;                             { temast alagava jada pikkus }
      k : integer;                              { milline on jadas jrgmine }
   end;

procedure loe_sisend;
var f : text; n, i : integer; x : nelik;
begin
   r := 0;
   assign (f, sisf); reset (f);
   readln (f, n);
   for i := 1 to n do begin
      readln (f,
         x.p1.x, x.p1.y,
         x.p2.x, x.p2.y,
         x.p3.x, x.p3.y,
         x.p4.x, x.p4.y);
      if on_ristk (x) then begin
         r := r + 1;
         a[r].n := i;
         a[r].x := x;
      end;
   end;
   close (f);
end;

procedure leia_jadad;
var i, j : integer; f : boolean;
begin
   for i := 1 to r do
      for j := 1 to r do
         a[i].m[j] := mahub (a[i].x, a[j].x);
   for i := 1 to r do begin
      a[i].p := 1;
      a[i].k := 0;
   end;
   repeat
      f := true;
      for i := 1 to r do
         for j := 1 to r do
            if a[i].m[j] then
               if a[j].p + 1 > a[i].p then begin
                  a[i].p := a[j].p + 1;
                  a[i].k := j;
                  f := false;
               end;
   until f;
end;

procedure valjasta;
var f : text; i, k : integer;
begin
   assign (f, valf); rewrite (f);
   if r > 0 then begin
      k := 1;
      for i := 1 to r do
         if a[i].p > a[k].p then
            k := i;
      writeln (f, a[k].p);
      while k > 0 do begin
         writeln (f, a[k].n);
         k := a[k].k;
      end;
   end else
      writeln (f, 0);
   close (f);
end;

begin
   loe_sisend;
   leia_jadad;
   valjasta;
end.