{$R+}{$Q+}{$S+}{$I+}{$N+}
const
 MAX_N = 50;
 MinLongInt = -MaxLongInt - 1;
 INPUT_FILE = 'PAANID.SIS';
 OUTPUT_FILE = 'PAANID.VAL';

type
 rectangle = record
                   x1, y1, x2, y2 : integer;
             end;
 solution = array[1 .. MAX_N * MAX_N] of rectangle;

var
 xs, ys:integer;
 map:array[1 .. MAX_N, 1 .. MAX_N] of longint;
 used:array[1 .. MAX_N, 1 .. MAX_N] of boolean;
 sums:array[0 .. MAX_N, 0 .. MAX_N] of longint;

 out_n:integer;
 out_sol:solution;

function max(a,b:longint):longint;
begin
 if (a < b) then max:=b else max:=a;
end;

function min(a,b:longint):longint;
begin
 if (a > b) then min:=b else min:=a;
end;

function ceil(r : double):longint;
var
 e : longint;

begin
    e := trunc(r);
    if (r > 0) and (r - e <> 0) then inc(e);
    ceil := e;
end;

function sum(x1, y1, x2, y2:integer):longint;
begin
     sum := sums[x2, y2] -
            (sums[x2, y1 - 1] + sums[x1 - 1, y2]) +
            sums[x1 - 1, y1 - 1];
end;

procedure read_input;
var
 f:text;
 x, y:integer;
begin
     assign(f, INPUT_FILE);
     reset(f);
     readln(f, ys, xs);

     for y := 1 to ys do
     begin
      for x := 1 to xs do
       read(f, map[x,y]);
      readln(f);
     end;
     close(f);
end;

procedure read_output;
var
 f:text;
 l:integer;
begin
     assign(f, OUTPUT_FILE);
     reset(f);
     readln(f, out_n);

     for l:=1 to out_n do
      readln(f, out_sol[l].y1, out_sol[l].x1, out_sol[l].y2, out_sol[l].x2);
     close(f);
end;


procedure verify;
var
 cur_max:longint;
 free_n:integer;
 x,y,l : integer;


 procedure init;
 var
  x, y:integer;
  s:longint;
 begin
     for x:=1 to xs do
      for y:=1 to ys do
       used[x,y]:=false;


     for x:=1 to xs do sums[x, 0] := 0;
     for y:=1 to ys do sums[0, y] := 0;

     for y:=1 to ys do
     begin
          s:=0;
          for x := 1 to xs do
          begin
               inc(s, map[x,y]);
               sums[x,y] := sums[x,y-1] + s;
          end;
     end;
 end;

begin
     Init;

     cur_max := MinLongInt;
     free_n := xs * ys;

     for l:=1 to out_n do
     begin

      for x := out_sol[l].x1 to out_sol[l].x2 do
       for y := out_sol[l].y1 to out_sol[l].y2 do
       if used[x,y] then
       begin
        writeln('Collision at (', x, ' , ', y, ').');
        exit;
       end
       else
       begin
        used[x,y]:= true;
        dec(free_n);
       end;

       cur_max := max(cur_max, sum(out_sol[l].x1, out_sol[l].y1,
                                   out_sol[l].x2, out_sol[l].y2));
     end;

     if (free_n <> 0) then
     begin
      writeln('Not all cells are covered.');
      exit;
     end;

     writeln('Output correct ', cur_max, '.');
end;

begin
 read_input;
 read_output;
 verify;
end.