{ 010429-3.PAS                                                              }
{ 2001-04-29 programmeerimisolmpiaadi 3. lesande testija                  }
{    RISTKLIKUD                                                            }
{ Ahto Truu                                                                 }

{$I-}

const
   maxn = 200;

type
   punkt = record
      x, y : integer;
   end;
   nelik = record
      p1, p2, p3, p4 : punkt;
   end;

{ arvutab punktidevahelise kauguse ruudu }
function kaug_ruut (var p1, p2 : punkt) : longint;
var dx, dy : longint;
begin
   dx := p1.x - p2.x;
   dy := p1.y - p2.y;
   kaug_ruut := sqr (dx) + sqr (dy);
end;

{ kontrollib, kas nelinurk on ristklik }
function on_ristk (var x : nelik) : boolean;
begin
   on_ristk := 
      (kaug_ruut (x.p1, x.p2) = kaug_ruut (x.p3, x.p4)) and
      (kaug_ruut (x.p1, x.p3) = kaug_ruut (x.p2, x.p4)) and
      (kaug_ruut (x.p1, x.p4) = kaug_ruut (x.p2, x.p3));
end;

{ vahetab kahe muutuja vrtused }
procedure vaheta (var l1, l2 : longint);
var l : longint;
begin
   l := l1; l1 := l2; l2 := l;
end;

{ kontrollib, kas teine ristklik mahub esimese sisse }
function mahub (var x1, x2 : nelik) : boolean;
var a1, b1, a2, b2, d2 : longint;
var s1, c1, s2, c2, s, c, h : real;
begin
   a1 := kaug_ruut (x1.p1, x1.p2); b1 := kaug_ruut (x1.p2, x1.p3);
   if a1 < b1 then
      vaheta (a1, b1);
   a2 := kaug_ruut (x2.p1, x2.p2); b2 := kaug_ruut (x2.p2, x2.p3);
   if a2 < b2 then
      vaheta (a2, b2);
   if (a2 < a1) and (b2 < b1) then begin
      mahub := true;
   end else if (a2 >= a1) and (b2 < b1) then begin
      d2 := a2 + b2;
      s1 := sqrt (d2 - a1); c1 := sqrt (a1);
      s2 := sqrt (b2); c2 := sqrt (a2);
      s := s1 * c2 + c1 * s2; c := c1 * c2 - s1 * s2;
      h := (sqrt (a2) * s + sqrt (b2) * c) / d2;
      mahub := sqr (h) < b1;
   end else begin
      mahub := false;
   end;
end;

var
   n : integer;                                           { nelinurkade arv }
   a : array [1..maxn] of record                       { nelinurkade andmed }
      x : nelik;                                             { nelinurk ise }
      r : boolean;                                       { kas on ristklik }
      m : array [1..maxn] of boolean;         { millised tema sisse mahuvad }
      p : integer;                             { temast alagava jada pikkus }
      k : integer;                              { milline on jadas jrgmine }
   end;
   p : integer;                                   { maksimaalne jada pikkus }

procedure loe_sisend;
var f : text; i : integer;
begin
   assign (f, paramstr (1)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' avamisel');
      halt (1);
   end;

   readln (f, n);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   for i := 1 to n do begin
      readln (f,
         a[i].x.p1.x, a[i].x.p1.y,
         a[i].x.p2.x, a[i].x.p2.y,
         a[i].x.p3.x, a[i].x.p3.y,
         a[i].x.p4.x, a[i].x.p4.y);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;

      a[i].r := on_ristk (a[i].x);
   end;

   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
end;

procedure leia_jadad;
var i, j : integer; f : boolean;
begin
   for i := 1 to n do
      for j := 1 to n do
         if a[i].r and a[j].r then
            a[i].m[j] := mahub (a[i].x, a[j].x);
   for i := 1 to n do begin
      a[i].p := 1;
      a[i].k := 0;
   end;
   repeat
      f := true;
      for i := 1 to n do
         for j := 1 to n do
            if a[i].r and a[j].r then
               if a[i].m[j] then
                  if a[j].p + 1 > a[i].p then begin
                     a[i].p := a[j].p + 1;
                     a[i].k := j;
                     f := false;
                  end;
   until f;
   p := 0;
   for i := 1 to n do
      if a[i].r then
         if a[i].p > p then
            p := a[i].p;
end;

var
   f : text;
   p1, n1, n2, i : integer;
begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   loe_sisend;
   leia_jadad;

   { loeme vistleja vastuse }
   assign (f, paramstr (2)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   readln (f, p1);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   if p1 = p then
      writeln ('Jada pikkus ', p1, ' ige')
   else
      writeln ('*** Jada pikkus ', p1, ' vale (peaks olema ', p, ')');

   for i := 1 to p1 do begin
      read (f, n2);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;

      if (n2 < 1) or (n2 > n) then begin
         writeln ('*** Lubamatu nelinurga number ', n2);
         halt (1);
      end;

      if not a[n2].r then begin
         writeln ('*** Mitteristkliku number ', n2);
         halt (1);
      end;

      if i > 1 then
         if not (a[n1].m[n2]) then begin
            writeln ('*** Ristklik number ', n2, ' ei mahu ristkliku number ', n1, ' sisse');
            halt (1);
         end;

      n1 := n2;
   end;

   if not seekeof (f) then begin
      writeln ('*** Liigne lbu faili ', paramstr (2), ' lpus');
      halt (1);
   end;

   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   writeln ('OK');
end.